/*

  File DFFT.ccp:

  Calcola i coefficienti dello sviluppo di Fourier di
  una funzione periodica generica come DFT.cpp, ma
  usa la classe FFT (basata sulla libreria fftw) per il
  calcolo "fast" dei coefficienti di Fourier.

*/


#include <iostream>
#include <fstream>
#include "FFT.h"
using namespace std;


main()
{
  cout << "Calcolo dello sviluppo di Fourier discreto di una funzione periodica letta da file" << endl;

  cout << "Nome del file da cui leggere la funzione: ";
  char fname[256];
  cin >> fname;

  long N;
  cout << "Numero N di sottointervalli (N+1 punti nodali): ";
  cin >> N;

  // Legge da file la funzione sui punti nodali

  double *x = new double[N];
  double *f = new double[N];

  ifstream finp;
  finp.open( fname );
  finp.precision( 15 );

  for ( long i = 0; i < N; i++ )
    {
      finp >> x[i] >> f[i];
    }
  double dx = x[1] - x[0];
  double L  = N * dx;
  finp.close();


  // Calcolo dei coefficienti di Fourier della funzione

  long Kmax = N / 2;                  // Frequenza di Nyquist
  double *ar = new double[Kmax+1];    // Parte reale del coefficiente di Fourier
  double *ai = new double[Kmax+1];    // Parte immag. del coefficiente di Fourier

  FFT myFFT = FFT( N );               // Crea l'oggetto myFFT

  myFFT.DT( f, ar, ai );

  // Stampa del risultato

  cout << "Inserire il nome del file dei risultati: ";
  cin >> fname;
  ofstream fout;
  fout.open( fname );
  fout.precision( 15 );

  for ( long k = 0; k <= Kmax; k++ )
    {
      double Ek = L * ( ar[k] * ar[k] + ai[k] * ai[k] );
      if ( k != 0 ) Ek = 2.0 * Ek;
      fout << k << "   " << ar[k] << "   " << ai[k] << "   " << Ek << endl;
    }

  fout.close();
}
