/*

  Classe FFT:
  calcola la Fast Fourier Transform diretta o inversa di un dataset
  reale/complesso.

  Utilizza le librerie FFTW.

*/

#include <fftw3.h>
using namespace std;

#ifndef FFT_H

#define FFT_H

class FFT
{

 private:

  long N, N2;
  fftw_plan planf, planb;
  double * datar;
  fftw_complex * datac; 

 public:

  FFT( long );          // Costruttore della classe: inizializza FFT e vettori
  ~FFT( );              // Distruttore della classe: rimuove vettori allocati
  void DT( double *, double *, double * );    // Trasformata diretta: R -> C
  void IT( double *, double *, double * );    // Trasformata inversa: C -> R (nota: stesso ordine dei parametri!)

};

#endif
