/*

  File Funzione.ccp:

  Scrive su un file i valori di una funzione periodica da analizzare
  tramite FT.

*/


#include <iostream>
#include <cmath>
#include <fstream>
using namespace std;

// Funzione da integrare: dente di sega nell'intervallo [0,L]

double Sawtooth( double x, double L )
{
  double f;

  if ( ( 0.0 <= x ) && ( x < 0.5 * L ) ) f = x;
  else if ( x == 0.5 * L ) f = 0.0;
  else f = x - L;
  return( f );
}

// Altra funzione: impulso rettangolare nell'intervallo [0,L]

double Pulse( double x, double L )
{
  double f;

  if ( ( x < 0.25 * L ) || ( x > 0.75 * L ) ) f = 0.0;
  else if ( ( x == 0.25 * L ) || ( x == 0.75 * L ) ) f = 0.5;
  else f = 1.0;
  return( f );
}


main()
{
  cout << "Scrittura su file di una funzione periodica per successiva analisi di Fourier" << endl;

  long N;
  cout << "Numero N di sottointervalli (N+1 punti nodali): ";
  cin >> N;

  int itype;
  cout << "Tipo di funzione:" << endl;
  cout << " 1 - dente di sega nell\'intervallo [0,L]" << endl;
  cout << " 2 - impulso rettangolare nell\'intervallo [-L,+L]" << endl;
  cin >> itype;

  // Definisce la funzione sui punti nodali

  double L = 1.0;
  double dx = L / N;
  double *x = new double[N];
  double *f = new double[N];

  for ( long i = 0; i < N; i++ )
    {
      x[i] = i * dx;
      switch ( itype )
	{
	case 1:
	  f[i] = Sawtooth( x[i], L );
	  break;
	case 2:
	  f[i] = Pulse( x[i], L );
	  break;
	}
    }

  cout << "Nome del file di output: ";
  char fname[256];
  cin >> fname;
  ofstream fout;
  fout.open( fname );
  fout.precision( 15 );

  for ( long i = 0; i < N; i++ )
    {
      fout << x[i] << "   " << f[i] << endl;
    }

  fout.close();

}
