/*

  File IDFFT.ccp:

  Calcola la trasformata inversa di Fourier a partire dai coefficienti letti da file
  con un numero specificato di armoniche, utilizzando la classe FFT (libreria fftw).

*/


#include <iostream>
#include <cmath>
#include <fstream>
#include "FFT.h"
using namespace std;


main()
{
  cout << "Ricostruisce una funzione a partire dai suoi coefficienti di Fourier letti da file" << endl;

  cout << "Nome del file da cui leggere i coefficienti di Fourier: ";
  char fname[256];
  cin >> fname;

  long Kmax;
  cout << "Numero max di armoniche (Kmax, numero di Nyquist): ";
  cin >> Kmax;

  double L;
  cout << "Lunghezza di periodicita\': ";
  cin >> L;
  double dpl = 2.0 * acos( -1.0 ) / L;

  long Kr = 2 * Kmax;
  while ( Kr > Kmax )
    {
      cout << "Numero di armoniche da utilizzare per la ricostruzione: ";
      cin >> Kr;
    }

  // Legge i coefficienti di Fourier da file

  long *kk = new long[Kmax+1];
  double *ar = new double[Kmax+1];
  double *ai = new double[Kmax+1];

  ifstream finp;
  finp.open( fname );
  finp.precision( 15 );

  double Ek;
  for ( long i = 0; i <= Kmax; i++ )
    {
      finp >> kk[i] >> ar[i] >> ai[i] >> Ek;
      if ( i > Kr )
	{
	  ar[i] = 0.0;
	  ai[i] = 0.0;
	}
    }
  finp.close();


  // Inizializzazione della funzione da ricostruire

  long N = 2 * Kmax;
  double dx = L / N;
  double *x = new double[N];
  double *f = new double[N];
  for ( long i = 0; i < N; i++ ) x[i] = i * dx;

  // Crea l'oggetto myFFT

  FFT myFFT = FFT( N );

  // Calcola la trasformata inversa

  myFFT.IT( f, ar, ai );

  // Stampa del risultato

  cout << "Inserire il nome del file dei risultati: ";
  cin >> fname;
  ofstream fout;
  fout.open( fname );
  fout.precision( 15 );

  for ( long i = 0; i < N; i++ )
    {
      fout << x[i] << "   " << f[i] << endl;
    }

  fout.close();
}
